// BonSrcDecoder1seg.cpp: CBonSrcDecoder1seg NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <process.h>
#include <TypeInfo.h>
#include "BonSrcDecoder1seg.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif


typedef IBonDriver* (PFCREATEBONDRIVER)(void);


//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CBonSrcDecoder1seg::CBonSrcDecoder1seg( IEventHandler *pEventHandler )
	: CMediaDecoder(pEventHandler, 0UL, 1UL)
	, m_piBonDriver(NULL)
	, m_piBonDriver2(NULL)
	, m_hStreamRecvThread(NULL)
	, m_bKillSignal(false)
	, m_TsStream(0x10000UL)
	, m_bIsPlaying(false)
	, m_StreamThreadPriority(THREAD_PRIORITY_NORMAL)
{
}

CBonSrcDecoder1seg::~CBonSrcDecoder1seg()
{
	this->CloseTuner();
}

void CBonSrcDecoder1seg::Reset(void)
{
	if (this->m_piBonDriver == NULL)
		return;

	if (!this->PauseStreamRecieve()) {
		Trace(TEXT("Xg[MXbh܂B"));
		return;
	}

	// ̃Xg[j
	this->m_piBonDriver->PurgeTsStream();

	this->ResumeStreamRecieve();
}

const bool CBonSrcDecoder1seg::InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex)
{
	// \[XfR[_̂ߓ͂͏Ȃ
	return false;
}

const bool CBonSrcDecoder1seg::OpenTuner( IBonDriver* t_piBonDriver )
{
	// I[v`FbN
	if( this->m_piBonDriver )
	{
		SetError(ERR_ALREADYOPEN,NULL);
		return false;
	}

	Trace(TEXT("`[iJĂ܂..."));

	this->m_piBonDriver = t_piBonDriver;

	HANDLE t_hThread = ::GetCurrentThread();
	int t_nThreadPriority = ::GetThreadPriority( t_hThread );

	// `[iJ
	if( !this->m_piBonDriver->OpenTuner() )
	{
		SetError(ERR_TUNEROPEN,TEXT("`[iJ܂B"),
							   TEXT("IBonDriver::OpenTuner()̌ĂяoŃG[Ԃ܂B"));
		goto OnError;
	}

	// BonDriver_HDUSAȂɃXbh̗DxHIGHESTɂ̂Ōɖ߂
	::SetThreadPriority( t_hThread, t_nThreadPriority );

	// IBonDriver2C^tF[X擾
	this->m_piBonDriver2 = dynamic_cast<IBonDriver2 *>( this->m_piBonDriver );

	// Xg[MXbhN
	if( !this->m_cPauseEvent.Create( true )
	 || !this->m_cResumeEvent.Create()
	 || !this->m_cBreakEvent.Create() )
	{
		SetError(ERR_INTERNAL, TEXT("CxgIuWFNg쐬ł܂B"));
		goto OnError;
	}
	this->m_bKillSignal = false;
	this->m_bIsPlaying = false;

//	this->m_hStreamRecvThread = ::CreateThread( NULL, 0UL, CBonSrcDecoder1seg::StreamRecvThread, this, 0UL, NULL );
	this->m_hStreamRecvThread = (HANDLE)::_beginthreadex( NULL, 0UL, CBonSrcDecoder1seg::StreamRecvThread, this, 0UL, NULL );
	if( !this->m_hStreamRecvThread )
	{
		this->SetError(ERR_INTERNAL, TEXT("Xg[MXbh쐬ł܂B"));
		goto OnError;
	}

	this->ClearError();

	Trace(TEXT("`[iJ܂B"));

	return true;

OnError:
	this->m_piBonDriver->CloseTuner();
//	this->m_piBonDriver->Release();
	this->m_piBonDriver = NULL;
	this->m_piBonDriver2 = NULL;
	this->m_cPauseEvent.Close();
	this->m_cResumeEvent.Close();
	this->m_cBreakEvent.Close();
	return false;
}

const bool CBonSrcDecoder1seg::CloseTuner(void)
{
	// Xg[~
	this->m_bIsPlaying = false;

	if( this->m_hStreamRecvThread )
	{
		// Xg[MXbh~
		Trace(TEXT("Xg[MXbh~Ă܂..."));
		this->m_bKillSignal = true;
		if( this->m_cPauseEvent.SignalAndWait( this->m_hStreamRecvThread, 5000UL ) != WAIT_OBJECT_0 )
		{
			// XbhI
			::TerminateThread( this->m_hStreamRecvThread, 0UL );
			Trace(TEXT("Xg[MXbhI܂B"));
		}
		::CloseHandle( this->m_hStreamRecvThread );
		this->m_hStreamRecvThread = NULL;
	}
	this->m_cPauseEvent.Close();
	this->m_cResumeEvent.Close();
	this->m_cBreakEvent.Close();

	if( this->m_piBonDriver )
	{
		// `[i
		Trace(TEXT("`[iĂ܂..."));
		this->m_piBonDriver->CloseTuner();

		// hCoCX^XJ
		Trace(TEXT("hCoĂ܂..."));
//		this->m_piBonDriver->Release();
		this->m_piBonDriver = NULL;
		this->m_piBonDriver2 = NULL;
		Trace(TEXT("`[i܂B"));
	}

	this->ClearError();

	return true;
}

const bool CBonSrcDecoder1seg::IsOpen() const
{
	return this->m_piBonDriver != NULL;
}

const bool CBonSrcDecoder1seg::Play(void)
{
	TRACE(TEXT("CBonSrcDecoder1seg::Play()\n"));

	if( this->m_piBonDriver == NULL )
	{
		// `[iJĂȂ
		this->SetError(ERR_NOTOPEN,NULL);
		return false;
	}

	if( this->m_bIsPlaying )
	{
		// ɍĐ
		/*
		SetError(ERR_ALREADYPLAYING,NULL);
		return false;
		*/
		return true;
	}

	if( !this->PauseStreamRecieve() )
	{
		this->SetError(ERR_TIMEOUT,TEXT("Xg[MXbh܂B"));
		return false;
	}

	// ̃Xg[j
	this->m_piBonDriver->PurgeTsStream();

	// ʃfR[_Zbg
	this->ResetDownstreamDecoder();

	// Xg[ĐԂɂ
	this->m_bIsPlaying = true;

	this->ResumeStreamRecieve();

	this->ClearError();

	return true;
}

const bool CBonSrcDecoder1seg::Stop(void)
{
	TRACE(TEXT("CBonSrcDecoder1seg::Stop()\n"));

	if ( !this->m_bIsPlaying )
	{
		// Xg[͍ĐłȂ
		/*
		SetError(ERR_NOTPLAYING,NULL);
		return false;
		*/
		return true;
	}

	if ( !this->PauseStreamRecieve() )
	{
		SetError(ERR_TIMEOUT,TEXT("Xg[MXbh܂B"));
		return false;
	}

	this->m_bIsPlaying = false;

	this->ResumeStreamRecieve();

	this->ClearError();

	return true;
}

void CBonSrcDecoder1seg::OnTsStream(BYTE *pStreamData, DWORD dwStreamSize)
{
	if( this->m_bIsPlaying )
	{
		// ŏʃfR[_ɓ͂
		this->m_TsStream.SetData( pStreamData, dwStreamSize );
		this->OutputMedia( &this->m_TsStream );
	}
}


//DWORD WINAPI CBonSrcDecoder1seg::StreamRecvThread(LPVOID pParam)
UINT32 WINAPI CBonSrcDecoder1seg::StreamRecvThread(LPVOID pParam)
{
	CBonSrcDecoder1seg *pThis = static_cast<CBonSrcDecoder1seg *>(pParam);

	::CoInitialize(NULL);

	::SetThreadPriority(::GetCurrentThread(),pThis->m_StreamThreadPriority);

	// `[iTSf[^oXbh
	while (true)
	{
		while( !pThis->m_cPauseEvent.IsSignaled() )
		{
			// ȗ̂߃|[O̗p
			DWORD t_dwStreamRemain = 0UL;

			do
			{
				BYTE* t_pStreamData = NULL;
				DWORD t_dwStreamSize = 0UL;

				if( pThis->m_piBonDriver->GetTsStream( &t_pStreamData, &t_dwStreamSize, &t_dwStreamRemain )
						&& t_pStreamData && t_dwStreamSize )
				{
#if 1
					pThis->OnTsStream( t_pStreamData, t_dwStreamSize );
#else
					// xɑTCYCPUgp̕ϓȂȂ
					DWORD Remain,Size;

					for (Remain=dwStreamSize;Remain>0;Remain-=Size) {
						Size=min(Remain,188*64);
						pThis->OnTsStream(pStreamData+(dwStreamSize-Remain),Size);
					}
#endif
				}

				if( pThis->m_cPauseEvent.IsSignaled() )
				{
					goto Break;
				}
			} while( t_dwStreamRemain > 0 );

#if 1
			// EFCg(24MbpsƂĎ̃f[^܂Ŗ15ms)
			::Sleep( 5UL );
#else
			// WaitTsStream ő҂ƕׂオ炵
			pThis->m_pBonDriver->WaitTsStream(20);
#endif
		}
	Break:
		if( pThis->m_bKillSignal )
		{
			break;
		}
		pThis->m_cPauseEvent.Reset();
		pThis->m_cResumeEvent.Reset();
		pThis->m_cBreakEvent.SignalAndWait( &pThis->m_cResumeEvent, 20000 );
	}

	::CoUninitialize();

	TRACE(TEXT("CBonSrcDecoder1seg::StreamRecvThread() return\n"));

	return 0UL;
}

/*
	Xg[̎Mꎞ~
	PurgeXg[ǂ݂ɍsė邱Ƃ̂ŁȂ΍
*/
bool CBonSrcDecoder1seg::PauseStreamRecieve( DWORD TimeOut )
{
	this->m_cBreakEvent.Reset();
	if( this->m_cPauseEvent.SignalAndWait( &this->m_cBreakEvent, TimeOut ) == WAIT_TIMEOUT )
	{
		this->m_cPauseEvent.Reset();
		return false;
	}
	return true;
}


bool CBonSrcDecoder1seg::ResumeStreamRecieve( DWORD TimeOut )
{
	this->m_cResumeEvent.Set();
	return true;
}
