#pragma once

#include <set>
#include "MediaDecoder.h"
#include "TsStream.h"

// ŒlPIDe[uŕ\IvV
#define _ENABLE_STATICPASSTABLE 0	// ̂Ƃ͔͈͂œĂĂ܂Ă̂Ŗgp

// ZỎfEEf[^̊eXg[IIɗ߂̃IvV
#define _ENABLE_STREAM_FILTER 1		// gpłȂ̂Ŏ...

// TSpPbg ZOtB^[
class CTs1segFilter : public CMediaDecoder
{
public:
	CTs1segFilter(IEventHandler *pEventHandler = NULL);
	virtual ~CTs1segFilter();

// CMediaDecoder
	virtual void Reset();
	virtual const bool InputMedia(CMediaData *pMediaData, const DWORD dwInputIndex = 0UL);

	virtual void SetUpdatePat( BOOL t_bUpdate );
#if _ENABLE_STREAM_FILTER
	virtual void EnabledStreamFilter( BOOL t_bEnabled );
	virtual void EnabledVideoStream( BOOL t_bEnabled );
	virtual void EnabledAudioStream( BOOL t_bEnabled );
	virtual void EnabledCaptionStream( BOOL t_bEnabled );
	virtual void EnabledDataStream( BOOL t_bEnabled );
	virtual void SetUpdatePmt( BOOL t_bUpdate );
#endif
protected:
	virtual void PatProcessor( CTsPacket* t_pcTsPacket );
	virtual void PmtProcessor( CTsPacket* t_pcTsPacket );

	BOOL m_bUpdatePat;
#if _ENABLE_STREAM_FILTER
	BOOL m_bEnableStreamFilter;
	BOOL m_bEnableVideoStream;
	BOOL m_bEnableAudioStream;
	BOOL m_bEnableCaptionStream;
	BOOL m_bEnableDataStream;
	BOOL m_bUpdatePmt;
#endif

	// ʉ߂PID
	std::set< WORD > m_wDynamicPassTable;
#if _ENABLE_STATICPASSTABLE
	std::set< WORD > m_wStaticPassTable;
#endif
};
